#include <ROL_Elementwise_Function.hpp>
#include <ROL_Elementwise_Reduce.hpp>
#include <ROL_Sketch.hpp>
#include <ROL_Vector.hpp>
#include <Teuchos_ENull.hpp>
#include <Teuchos_RCPDecl.hpp>
#include <Teuchos_RCPNode.hpp>
#include <ios>
#include <memory>
#include <ostream>
#include <sstream> // __str__
#include <streambuf>
#include <string>
#include <vector>

#include <functional>
#include <pybind11/pybind11.h>
#include <string>
#include <Teuchos_RCP.hpp>


#ifndef BINDER_PYBIND11_TYPE_CASTER
	#define BINDER_PYBIND11_TYPE_CASTER
	PYBIND11_DECLARE_HOLDER_TYPE(T, Teuchos::RCP<T>, false)
	PYBIND11_DECLARE_HOLDER_TYPE(T, T*, false)
	PYBIND11_MAKE_OPAQUE(Teuchos::RCP<void>)
#endif

void bind_pyrol_68(std::function< pybind11::module &(std::string const &namespace_) > &M)
{
	{ // ROL::Sketch file:ROL_Sketch.hpp line:65
		pybind11::class_<ROL::Sketch<double>, Teuchos::RCP<ROL::Sketch<double>>> cl(M("ROL"), "Sketch_double_t", "", pybind11::module_local());
		cl.def( pybind11::init( [](const class ROL::Vector<double> & a0, int const & a1, int const & a2){ return new ROL::Sketch<double>(a0, a1, a2); } ), "doc" , pybind11::arg("x"), pybind11::arg("ncol"), pybind11::arg("rank"));
		cl.def( pybind11::init( [](const class ROL::Vector<double> & a0, int const & a1, int const & a2, double const & a3){ return new ROL::Sketch<double>(a0, a1, a2, a3); } ), "doc" , pybind11::arg("x"), pybind11::arg("ncol"), pybind11::arg("rank"), pybind11::arg("orthTol"));
		cl.def( pybind11::init( [](const class ROL::Vector<double> & a0, int const & a1, int const & a2, double const & a3, int const & a4){ return new ROL::Sketch<double>(a0, a1, a2, a3, a4); } ), "doc" , pybind11::arg("x"), pybind11::arg("ncol"), pybind11::arg("rank"), pybind11::arg("orthTol"), pybind11::arg("orthIt"));
		cl.def( pybind11::init( [](const class ROL::Vector<double> & a0, int const & a1, int const & a2, double const & a3, int const & a4, bool const & a5){ return new ROL::Sketch<double>(a0, a1, a2, a3, a4, a5); } ), "doc" , pybind11::arg("x"), pybind11::arg("ncol"), pybind11::arg("rank"), pybind11::arg("orthTol"), pybind11::arg("orthIt"), pybind11::arg("truncate"));
		cl.def( pybind11::init( [](const class ROL::Vector<double> & a0, int const & a1, int const & a2, double const & a3, int const & a4, bool const & a5, unsigned int const & a6){ return new ROL::Sketch<double>(a0, a1, a2, a3, a4, a5, a6); } ), "doc" , pybind11::arg("x"), pybind11::arg("ncol"), pybind11::arg("rank"), pybind11::arg("orthTol"), pybind11::arg("orthIt"), pybind11::arg("truncate"), pybind11::arg("dom_seed"));
		cl.def( pybind11::init<const class ROL::Vector<double> &, int, int, double, int, bool, unsigned int, unsigned int>(), pybind11::arg("x"), pybind11::arg("ncol"), pybind11::arg("rank"), pybind11::arg("orthTol"), pybind11::arg("orthIt"), pybind11::arg("truncate"), pybind11::arg("dom_seed"), pybind11::arg("rng_seed") );

		cl.def( pybind11::init( [](ROL::Sketch<double> const &o){ return new ROL::Sketch<double>(o); } ) );
		cl.def("setStream", (void (ROL::Sketch<double>::*)(class Teuchos::RCP<std::ostream > &)) &ROL::Sketch<double>::setStream, "C++: ROL::Sketch<double>::setStream(class Teuchos::RCP<std::ostream > &) --> void", pybind11::arg("out"));
		cl.def("reset", [](ROL::Sketch<double> &o) -> void { return o.reset(); }, "");
		cl.def("reset", (void (ROL::Sketch<double>::*)(bool)) &ROL::Sketch<double>::reset, "C++: ROL::Sketch<double>::reset(bool) --> void", pybind11::arg("randomize"));
		cl.def("setRank", (void (ROL::Sketch<double>::*)(int)) &ROL::Sketch<double>::setRank, "C++: ROL::Sketch<double>::setRank(int) --> void", pybind11::arg("rank"));
		cl.def("update", (void (ROL::Sketch<double>::*)()) &ROL::Sketch<double>::update, "C++: ROL::Sketch<double>::update() --> void");
		cl.def("advance", [](ROL::Sketch<double> &o, double const & a0, const class ROL::Vector<double> & a1, int const & a2) -> int { return o.advance(a0, a1, a2); }, "", pybind11::arg("nu"), pybind11::arg("h"), pybind11::arg("col"));
		cl.def("advance", (int (ROL::Sketch<double>::*)(double, const class ROL::Vector<double> &, int, double)) &ROL::Sketch<double>::advance, "C++: ROL::Sketch<double>::advance(double, const class ROL::Vector<double> &, int, double) --> int", pybind11::arg("nu"), pybind11::arg("h"), pybind11::arg("col"), pybind11::arg("eta"));
		cl.def("reconstruct", (int (ROL::Sketch<double>::*)(class ROL::Vector<double> &, const int)) &ROL::Sketch<double>::reconstruct, "C++: ROL::Sketch<double>::reconstruct(class ROL::Vector<double> &, const int) --> int", pybind11::arg("a"), pybind11::arg("col"));
		cl.def("test", [](ROL::Sketch<double> &o, const int & a0) -> bool { return o.test(a0); }, "", pybind11::arg("rank"));
		cl.def("test", [](ROL::Sketch<double> &o, const int & a0, std::ostream & a1) -> bool { return o.test(a0, a1); }, "", pybind11::arg("rank"), pybind11::arg("outStream"));
		cl.def("test", (bool (ROL::Sketch<double>::*)(const int, std::ostream &, const int)) &ROL::Sketch<double>::test, "C++: ROL::Sketch<double>::test(const int, std::ostream &, const int) --> bool", pybind11::arg("rank"), pybind11::arg("outStream"), pybind11::arg("verbosity"));
	}
}
